/*
 * Copyright (c) 2021 The Linux Foundation. All rights reserved.
 * Copyright (c) 2023 Qualcomm Innovation Center, Inc. All rights reserved.
 *
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/**
 * DOC: i_qdf_irq.h
 * This file provides OS dependent interrupt API's.
 */

#ifndef _I_QDF_IRQ_H
#define _I_QDF_IRQ_H

#include <linux/irq.h>
#include <linux/irqreturn.h>

#define __QDF_IRQ_TYPE_NONE		IRQ_TYPE_NONE
#define __QDF_IRQ_TYPE_EDGE_RISING	IRQ_TYPE_EDGE_RISING
#define __QDF_IRQ_TYPE_EDGE_FALLING	IRQ_TYPE_EDGE_FALLING
#define __QDF_IRQ_TYPE_EDGE_BOTH	IRQ_TYPE_EDGE_BOTH
#define __QDF_IRQ_TYPE_LEVEL_HIGH	IRQ_TYPE_LEVEL_HIGH
#define __QDF_IRQ_TYPE_LEVEL_LOW	IRQ_TYPE_LEVEL_LOW
#define __QDF_IRQ_TYPE_LEVEL_MASK	IRQ_TYPE_LEVEL_MASK
#define __QDF_IRQ_TYPE_SENSE_MASK	IRQ_TYPE_SENSE_MASK
#define __QDF_IRQ_TYPE_DEFAULT		IRQ_TYPE_DEFAULT
#define __QDF_IRQ_TYPE_PROBE		IRQ_TYPE_PROBE
#define __QDF_IRQ_LEVEL			IRQ_LEVEL
#define __QDF_IRQ_PER_CPU		IRQ_PER_CPU
#define __QDF_IRQ_NOPROBE		IRQ_NOPROBE
#define __QDF_IRQ_NOREQUEST		IRQ_NOREQUEST
#define __QDF_IRQ_NOAUTOEN		IRQ_NOAUTOEN
#define __QDF_IRQ_NO_BALANCING		IRQ_NO_BALANCING
#define __QDF_IRQ_MOVE_PCNTXT		IRQ_MOVE_PCNTXT
#define __QDF_IRQ_NESTED_THREAD		IRQ_NESTED_THREAD
#define __QDF_IRQ_NOTHREAD		IRQ_NOTHREAD
#define __QDF_IRQ_PER_CPU_DEVID		IRQ_PER_CPU_DEVID
#define __QDF_IRQ_IS_POLLED		IRQ_IS_POLLED
#define __QDF_IRQ_DISABLE_UNLAZY	IRQ_DISABLE_UNLAZY
#define __QDF_IRQF_SHARED		IRQF_SHARED
#define __QDF_IRQF_TRIGGER_RISING	IRQF_TRIGGER_RISING
#define __QDF_IRQ_NONE			IRQ_NONE
#define __QDF_IRQ_HANDLED		IRQ_HANDLED

#endif /* _I_QDF_IRQ_H */
